/*
**  cross-browser compatible
*/

function stopErrors(){return true;}
window.onerror=stopErrors;

var isOP=(navigator.userAgent.indexOf('Opera')!=-1);
var isIE=(navigator.userAgent.indexOf('MSIE')!=-1 && !isOP);

// creates a positioned element from its named template
function getElm(name){
	var x = new Object;
	var d=document;
	if(d.layers){
		x.elm=d.layers[name];
		x.obj=x.elm;
		x.width=x.obj.clip.width;
		x.height=x.obj.clip.height;
	}else if(d.all){
		x.elm=d.all[name];
		x.obj=x.elm.style;
		x.width=parseInt(x.obj.width);
		x.height=parseInt(x.obj.height);
	}else if(d.getElementById){
		x.elm=d.getElementById(name);
		x.obj=x.elm.style;
		x.width=parseInt(x.obj.width);
		x.height=parseInt(x.obj.height);
	}
	x.oldZ=x.obj.zIndex;
	x.id=x.elm.id;
	x.setDim=function(w,h){
		if(w<5)w=5;
		this.width=w;
		this.obj.width=w;
		if(h<5)h=5;
		this.height=h;
		this.obj.height=h;
		if(this.obj.clip.width && this.obj.clip.height){
			this.obj.clip.width=w;
			this.obj.clip.height=h;
		}else{
			this.obj.clip='rect(0 '+w+' '+h+' 0)';
		}
	}
	return x;
}

// handles mousedown
var dragee,winWidth,winHeight
function mDown(e){
	//define position of mouse (posx,posy)
	if(!e)var e=window.event;
	e.cancelBubble=true;
	if (e.preventBubble) { e.preventBubble(); e.preventDefault(); e.preventCapture(); e.stopPropagation(); }
	if(e.pageX||e.pageY){posx=e.pageX;posy=e.pageY;
	}else if(e.clientX||e.clientY){posx=e.clientX;posy=e.clientY;
		if(isIE){posx+=document.body.scrollLeft;posy+=document.body.scrollTop;}
	}
	//define the width and height of the window
	if(window.innerWidth && window.innerHeight){
		winWidth=window.innerWidth-16;
		//winHeight=window.innerHeight;
	}
	else{
		winWidth=document.body.offsetWidth-20;
		//winHeight=document.body.offsetHeight-4;
		//if(isIE){winHeight+=document.body.scrollTop;}
	}

	//define target
	var target;
	if(e.target)target=e.target;
	else if(e.srcElement)target=e.srcElement;
	if(!target.id)target=this;
	//define dragee
	dragee=getElm(target.id);
	if(all[target.id])dragee.onMove=all[target.id].onMove;
	//put dragee on top
	//dragee.obj.zIndex=100;
	//define diference between initial mousedown and topright corner of dragee
	dragee.offX=posx-parseInt(dragee.obj.left);
	dragee.offY=posy-parseInt(dragee.obj.top);
	//set onmousemove and onmouseup event handler
	if(document.captureEvents)document.captureEvents(Event.MOUSEMOVE|Event.MOUSEUP);
	document.onmousemove=doDrag;
	document.onmouseup=mUp;
	dragOverlayObj.obj.display='block';
	var isResize = (e.target.id=='size');
	resizeTextObj.obj.display = isResize ? 'block' : 'none';
	moveTextObj.obj.display = isResize ? 'none' : 'block';
	
	//window.status = e.target.id;
	window.status='ResistanceToChange';
}

// handles mouseup
function mUp(name){
	//stop dragging
	document.onmousemove=null;
	if(document.releaseEvents)document.releaseEvents(Event.MOUSEMOVE);
	if(dragee){
		//give dragee its old zindex back
		//dragee.obj.zIndex=dragee.oldZ;
		dragee=null;
	}
	//scrollbar adjust for NN4
	if(document.layers){
		var newDocumentHeight=0;//document.height
		for(var i=0; i<document.layers.length; i++){
			var lyr=document.layers[i];
			if(lyr.clip)newDocumentHeight=Math.max(newDocumentHeight,lyr.top+lyr.clip.height);
		}
		document.height=newDocumentHeight;
	}
	dragOverlayObj.obj.display='none';
	window.status = 'ResistanceToChange';
	setTimeout("window.status = ''", 1000);
}

// handles dragging
function doDrag(e){
	if(dragee){
		//define position of mouse
		if(!e)var e=window.event;
		e.cancelBubble=true;
		if (e.preventBubble) { e.preventBubble(); e.preventDefault(); e.preventCapture(); e.stopPropagation(); }
		if(e.pageX||e.pageY){posx=e.pageX;posy=e.pageY;
		}else if(e.clientX||e.clientY){posx=e.clientX;posy=e.clientY;
			if(isIE){posx+=document.body.scrollLeft;posy+=document.body.scrollTop;}
		}
		var tempLeft=posx-dragee.offX;
		var tempTop=posy-dragee.offY;
		if(tempLeft<0)tempLeft=0;
		else if(tempLeft>=(winWidth-dragee.width))tempLeft=(winWidth-dragee.width);
		if(tempTop<0)tempTop=0;
		//else if(tempTop>=winHeight-dragee.height)tempTop=(winHeight-dragee.height);
		dragee.obj.left=tempLeft;
		dragee.obj.top=tempTop;
		window.status='ResistanceToChange ( '+((tempLeft<10)?'000':(tempLeft<100)?'00':(tempLeft<1000)?'0':'')+tempLeft+', '+((tempTop<10)?'000':(tempTop<100)?'00':(tempTop<1000)?'0':'')+tempTop+' )';
		if(dragee.onMove)dragee.onMove(tempLeft,tempTop);
	}
	return false;
}
// initializes window-elements
var all=new Array;
function initWindowDrag(){
	sizeObj=getElm('size');
	if(sizeObj.elm.captureEvents)sizeObj.elm.captureEvents(Event.MOUSEDOWN);
	sizeObj.elm.onmousedown=mDown;
	all['size']=new Object;
	all['size'].onMove=function(l,t){
		outerObj.setDim(l+this.width-parseInt(outerObj.obj.left),t+this.height-parseInt(outerObj.obj.top));
		innerObj.setDim(l+this.width-3-parseInt(innerObj.obj.left),t+this.height-3-parseInt(innerObj.obj.top));
		titleObj.setDim(l+this.width-3-parseInt(innerObj.obj.left),10);
	}
	outerObj=getElm('outer');
	innerObj=getElm('inner');
	titleObj=getElm('title');
	dragOverlayObj=getElm('drag-overlay');
	resizeTextObj=getElm('drag-resize-text');
	moveTextObj=getElm('drag-move-text');
	if(titleObj.elm.captureEvents)titleObj.elm.captureEvents(Event.MOUSEDOWN);
	titleObj.elm.onmousedown=mDown;
	all['title']=new Object;
	all['title'].onMove=function(l,t){
		innerObj.obj.left=this.obj.left;
		outerObj.obj.left=parseInt(this.obj.left)-3;
		innerObj.obj.top=parseInt(this.obj.top)+12;
		outerObj.obj.top=parseInt(this.obj.top)-3;
		sizeObj.obj.left=parseInt(outerObj.obj.left)+outerObj.width-sizeObj.width;
		sizeObj.obj.top=parseInt(outerObj.obj.top)+outerObj.height-sizeObj.height;
	}
	all['ManualResize']=sizeObj;
	all['ManualResize'].sizeTo=function(w,h){
		w+=outerObj.width-innerObj.width;
		h+=outerObj.height-innerObj.height;
		innerObj.setDim(w-(outerObj.width-innerObj.width),h-(outerObj.height-innerObj.height));
		titleObj.setDim(w-(outerObj.width-titleObj.width),10);
		outerObj.setDim(w,h);
		sizeObj.obj.left = w-20+parseInt(outerObj.obj.left); sizeObj.obj.top = h-20+parseInt(outerObj.obj.top);
	}
	all['ManualCenter']=titleObj;
	all['ManualCenter'].center=function(){
		//winWidth = window.innerWidth - 16; winHeight = window.innerHeight - 16;
		var titleDiffX = parseInt(titleObj.obj.left)-parseInt(outerObj.obj.left), titleDiffY = parseInt(titleObj.obj.top)-parseInt(outerObj.obj.top);
		var innerDiffY = parseInt(innerObj.obj.top)-parseInt(titleObj.obj.top);
		var x = (window.innerWidth -  outerObj.width)  / 2;
		if (x < 16) x = 16;
		var y = (window.innerHeight - outerObj.height) / 2;
		if (y < 16) y = 16;
		titleObj.obj.left = x + titleDiffX;
		titleObj.obj.top =  y + titleDiffY;

		innerObj.obj.left=titleObj.obj.left;
		outerObj.obj.left=x; //parseInt(titleObj.obj.left) - titleDiffX;
		innerObj.obj.top=parseInt(titleObj.obj.top) + innerDiffY;
		outerObj.obj.top=y; //parseInt(titleObj.obj.top) - titleDiffY;
		sizeObj.obj.left=parseInt(outerObj.obj.left)+outerObj.width-sizeObj.width;
		sizeObj.obj.top=parseInt(outerObj.obj.top)+outerObj.height-sizeObj.height;
	}

}